【leetcode】167. Two Sum II - Input array is sorted【M】【100%】

Given an array of integers that is already sorted in ascending order, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

Subscribe to see which companies asked this question

双指针,二分查找,因为数组已经排好序了

注意一点就是,如果一个数上个循环已经查找过了,那就直接跳过。否则有的例子过不了


【这么长时间终于有一道题超过100%了!!!!】


class Solution(object):
    def biSearch(self,num,target):
        begin = 0
        end = len(num)
        while begin <= end:
            middle = (begin + end) / 2
            if middle >= len(num):
                break
            #print begin,middle,end
            if num[middle] == target:
                return middle
            elif num[middle] < target:
                begin = middle + 1 
            else:
                end = middle - 1
        return -1


    def twoSum(self, numbers, target):
        num = numbers
        #print num
        last = None
        for i in xrange(len(num)):
            if num[i] == last:
        	    continue
            res = self.biSearch(num[i+1:],target - num[i])
            if res != -1:
                return [1+i,2+i+res]
            last = num[i]


你可能感兴趣的:(leetcode,Python,算法,二分法,双指针,leetcode题解,leetcode,python,双指针,二分查找)